﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private cv As Canvas 	
	Private img As Image	
	Private AP As Pane
	Private wdt, hgt As Int
	Private flag As Boolean 
	Private sldNoise As Slider
	Private txtNoise As TextField
	Private rbColor As RadioButton
	Private drawMode As Short 
	Private Perc As Int 
End Sub
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	AP.Initialize("")

End Sub

Public Sub AddNoise (c As Canvas, fr As Form,  posy As Double )
	cv = c
	img = cv.Snapshot 
	wdt = img.Width 
	hgt=img.Height 
	AP.LoadLayout("fxAddNoise")
	flag=False
	sldNoise.MinValue = 1
	sldNoise.MaxValue = 500
	sldNoise.Value = 5
	fr.RootPane.AddNode(AP, 5, posy, -1, -1)
	DrawNoise
End Sub
Private Sub DrawNoise
	flag = True
	Dim r,g,b As Int
	Dim rgb(4) As Int
	Dim x, y As Int 
	Dim ARGB As Int
	Dim Clr As Paint	
	cv.ClearRect(0,0,cv.Width,cv.Height)	
	cv.DrawImage(img,0,0,wdt,hgt)	
	Dim InputJO, OutputJO, ReaderJO, WriterJO As JavaObject
	OutputJO.InitializeNewInstance("javafx.scene.image.WritableImage",Array As Object(wdt,hgt))
    Dim nColor As Int
	Dim Noise As Short = sldNoise.Value 
	Dim dNoise As Int
    'Double the amount of noise we plan on using (so we can add noise above or below the current color value)
    dNoise = Noise * 2
	InputJO = img
	ReaderJO = InputJO.RunMethod("getPixelReader",Null)
	WriterJO = OutputJO.RunMethod("getPixelWriter",Null)
	For y=0 To hgt-1
		For x=0 To wdt -1 
			'Get the source pixel color values
			ARGB = ReaderJO.RunMethod("getArgb",Array As Object(x,y))
			rgb = modFunctions.getRGB(ARGB)
			r = rgb(1)
			g = rgb(2)
			b = rgb(3)
			If drawMode = 0 Then
	            'Monochromatic noise - same amount for each color
				nColor =  Rnd(0,dNoise) - Noise
	            r = r + nColor
	            g = g + nColor
	            b = b + nColor			
			Else
            	'Colored noise - each color generated randomly
				r = r + Rnd(0,dNoise) - Noise
				g = g + Rnd(0,dNoise) - Noise
				b = b + Rnd(0,dNoise) - Noise
			End If
	        r = Min(Max(r,0),255)
	        g = Min(Max(g,0),255)  
	        b = Min(Max(b,0),255)
			Clr = fx.Colors.rgb(r,g, b)
			ARGB=fx.Colors.To32Bit(Clr)		
			WriterJO.RunMethod("setArgb",Array As Object(x , y ,ARGB))				
		Next
	Next
	cv.DrawImage(OutputJO,0,0,wdt,hgt)	
 
End Sub
Sub rbColor_SelectedChange(Selected As Boolean)
	Dim rb As RadioButton 
	Dim ct =0
	rb=Sender
	Select Case rb.Text 
		Case "Image Colors"
			If rb.Selected Then
				drawMode = 0
			End If
		Case "Random Colors"
			If rb.Selected  Then
				drawMode = 1
			End If
	End Select
	If flag Then DrawNoise
End Sub

Sub txtNoise_Action
	sldNoise.RequestFocus 
End Sub
Sub txtNoise_TextChanged (Old As String, New As String)
	Dim ch As String
	Dim lg As Int
	lg=New.Length
	If lg>0 Then
		lg=lg-1
		For i = 0 To lg
			ch=New.SubString2(i, i+1)
			If Not("0123456789".Contains(ch)) Then
				txtNoise.Text =Old
				txtNoise.SetSelection (lg, lg)
				Return
			End If
		Next
	End If		
End Sub
Sub txtNoise_FocusChanged (HasFocus As Boolean)
	If HasFocus Then
		txtNoise.Tag = 1
	Else
		txtNoise.Text = Max(Min(txtNoise.Text,sldNoise.MaxValue),sldNoise.MinValue)	
		sldNoise.Value= txtNoise.Text
	End If		
End Sub
Sub sldNoise_ValueChange (Value As Double)
	Dim v As Short =Value
	If txtNoise.Tag = 1 Then
		txtNoise.Tag = 0
	Else
		txtNoise.Text = v
	End If
	If flag Then DrawNoise
End Sub	
Public Sub ExitFunc
AP.RemoveNodeFromParent 
End Sub


