﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
'Original PhotoDemon VB6
'Copyright ©2013-2014 by Tanner Helland

Sub Class_Globals
	Private wdt, hgt As Int
	Private fx As JFX
	Private cv As Canvas 	
	Private img As Image	
	Private workingImg As Image 	
	Private AP As Pane		
	Private flag As Boolean 
	Private sldShades As Slider
	Private txtShades As TextField
	Private cboMethod As ComboBox
	Private cboDithering As ComboBox
	Private optDecompose As RadioButton
	Private OptRgb As RadioButton
	Private APDecompose As Pane
	Private APRgb As Pane
	Private MaxOrMin As Int 
	Private cChannel As Int
	Private numOfShades As Int 
	Private ditheringOptions As Int 
	Private grayscaleMethod As Int 
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	flag=False
	AP.Initialize("")
    cboMethod.Initialize("cboMethod")
	cboDithering.Initialize("cboDithering")
	optDecompose.Initialize("optDecompose")
	OptRgb.Initialize("OptRgb")
	APDecompose.Initialize("")
	APRgb.Initialize("")
End Sub
Public Sub BlackWhite(c As Canvas,fr As Form, posy As Double)
	cv = c
	img = cv.Snapshot 
	wdt = img.Width 
	hgt = img.Height
	AP.LoadLayout("fxBlackWhite")
    'Set up the grayscale options combo box
	cboMethod.Items.Clear 
	cboMethod.Items.Add("Fastest Calculation (average value)")
    cboMethod.Items.Add("Highest Quality (ITU Standard)")
    cboMethod.Items.Add("Desaturate")
    cboMethod.Items.Add("Decompose")
    cboMethod.Items.Add("Single color channel")
    cboMethod.SelectedIndex  = 1
   'Populate the dither combobox
    cboDithering.Items.Clear
    cboDithering.Items.Add("None")
    cboDithering.Items.Add("False (Fast) Floyd-Steinberg")
    cboDithering.Items.Add("Genuine Floyd-Steinberg")
    cboDithering.Items.Add("Jarvis, Judice, and Ninke")
    cboDithering.Items.Add("Stucki")
    cboDithering.Items.Add("Burkes")
    cboDithering.Items.Add("Sierra-3")
    cboDithering.Items.Add("Two-Row Sierra")
    cboDithering.Items.Add("Sierra Lite")
    cboDithering.Items.Add("Atkinson / Classic Macintosh")
    cboDithering.SelectedIndex = 0	
	set_rgbRadioCk("Red")	
	set_DecomposeRadioCk("Maximum")
	UpdateVisibleControls
	sldShades.MaxValue = 256
	sldShades.MinValue = 2
	sldShades.Value = 256
	fr.RootPane.AddNode(AP, 5, posy, -1, -1)
	updateImg
End Sub
'Preview the current grayscale conversion technique
Private Sub updateImg
	flag = True
	grayscaleMethod = cboMethod.SelectedIndex
	ditheringOptions = cboDithering.SelectedIndex
	numOfShades = sldShades.Value 
    masterGrayscaleFunction
End Sub
'All different grayscale (black and white) routines are handled by this single function. Grayscale operations
' are divided into four params: type of transform, optional params for transform (if any), number of shades to use, and
' dithering options (if any).  This should allow the user to mix and match the various options at their leisure.
Private Sub masterGrayscaleFunction
 	cv.ClearRect(0,0,cv.Width,cv.Height)	
    'Different grayscale conversion methods call different individual subs
    Select Case grayscaleMethod
        Case 0
            MenuGrayscaleAverage
        Case 1
            MenuGrayscale
        Case 2
           MenuDesaturate
        Case 3
			MaxOrMin = get_DecomposeRadioCk
           	MenuDecompose
        Case 4
			cChannel = get_rgbRadioCk
            MenuGrayscaleSingleChannel
    End Select
    'We now apply the user's choice of shade reduction and/or dithering.
    If numOfShades < 255  Then
        Select Case ditheringOptions
            Case 0
        		fGrayscaleCustom 
            Case Else
               fGrayscaleCustomDither
        End Select
        
    End If
   	cv.DrawImage(workingImg,0,0,wdt,hgt)				
End Sub
'Reduce to gray via (r+g+b)/3
Private Sub MenuGrayscaleAverage
    Dim x As Int, y As Int
	'Color and grayscale variables
    Dim r As Int, g As Int, b As Int
   	Dim rgb(4) As Int
	Dim ARGB,  lGray As Int
	Dim Clr As Paint	
    'Build a look-up table of grayscale values (faster than calculating it manually for each pixel)
    Dim grayLookUp(766) As Int
    For x = 0 To 765
        grayLookUp(x) = x / 3
    Next 
	Dim InputJO, OutputJO, ReaderJO, WriterJO As JavaObject
	OutputJO.InitializeNewInstance("javafx.scene.image.WritableImage",Array As Object(wdt,hgt))
	InputJO = img
	ReaderJO = InputJO.RunMethod("getPixelReader",Null)
	WriterJO = OutputJO.RunMethod("getPixelWriter",Null)	
    'Loop through each pixel in the image, converting values as we go
    For x = 0 To wdt - 1
		For y = 0 To hgt - 1
	        'Get the source pixel color values
			ARGB = ReaderJO.RunMethod("getArgb", Array As Object(x,y))
			rgb = modFunctions.getRGB(ARGB)
			r = rgb(1)
			g = rgb(2)
			b = rgb(3)
	        'Calculate the gray value using the look-up table
	        lGray = grayLookUp(r + g + b)
			Clr = fx.Colors.rgb(lGray, lGray, lGray)
			ARGB=fx.Colors.To32Bit(Clr)		
			WriterJO.RunMethod("setArgb",Array As Object(x , y ,ARGB))			        
	    Next 
    Next 
	workingImg = OutputJO
End Sub
Private Sub MenuGrayscale
	Dim x, y As Int
	Dim r,g,b As Int
	Dim rgb(4) As Int
	Dim ARGB,  lGray As Int
	Dim Clr As Paint
	Dim InputJO, OutputJO, ReaderJO, WriterJO As JavaObject
	OutputJO.InitializeNewInstance("javafx.scene.image.WritableImage",Array As Object(wdt,hgt))
	InputJO = img
	ReaderJO = InputJO.RunMethod("getPixelReader",Null)
	WriterJO = OutputJO.RunMethod("getPixelWriter",Null)		
	For y=0 To hgt-1
		For x=0 To wdt -1 
			ARGB = ReaderJO.RunMethod("getArgb",Array As Object(x,y))
			rgb = modFunctions.getRGB(ARGB)
			r = rgb(1)
			g = rgb(2)
			b = rgb(3)
           	lGray = (213.0 * r + 715.0 * g + 72.0 * b) / 1000
			Clr = fx.Colors.rgb(lGray, lGray, lGray)
			lGray=fx.Colors.To32Bit(Clr)
			WriterJO.RunMethod("setArgb",Array As Object(x , y ,lGray))				
		Next
	Next
	workingImg = OutputJO
End Sub
Public Sub MenuDesaturate
	Dim x, y As Int
	Dim r,g,b As Int
	Dim rgb(4) As Int
	Dim ARGB,  lGray As Int
	Dim Clr As Paint
	Dim InputJO, OutputJO, ReaderJO, WriterJO As JavaObject
	OutputJO.InitializeNewInstance("javafx.scene.image.WritableImage",Array As Object(wdt,hgt))
	InputJO = img
	ReaderJO = InputJO.RunMethod("getPixelReader",Null)
	WriterJO = OutputJO.RunMethod("getPixelWriter",Null)		
	For y=0 To hgt-1
		For x=0 To wdt -1 
			ARGB = ReaderJO.RunMethod("getArgb",Array As Object(x,y))
			rgb = modFunctions.getRGB(ARGB)
			r = rgb(1)
			g = rgb(2)
			b = rgb(3)
           	lGray = modFunctions.getLuminance(r, g, b)
			Clr = fx.Colors.rgb(lGray, lGray, lGray)
			lGray=fx.Colors.To32Bit(Clr)
			WriterJO.RunMethod("setArgb",Array As Object(x , y ,lGray))				
		Next
	Next
	workingImg = OutputJO
End Sub
'Reduce to gray by selecting the minimum (maxOrMin = 0) or maximum (maxOrMin = 1) color in each pixel
Public Sub MenuDecompose
	Dim x, y As Int
	Dim r,g,b As Int
	Dim rgb(4) As Int
	Dim ARGB,  lGray As Int
	Dim Clr As Paint
	Dim InputJO, OutputJO, ReaderJO, WriterJO As JavaObject
	OutputJO.InitializeNewInstance("javafx.scene.image.WritableImage",Array As Object(wdt,hgt))
	InputJO = img
	ReaderJO = InputJO.RunMethod("getPixelReader",Null)
	WriterJO = OutputJO.RunMethod("getPixelWriter",Null)		
    'Loop through each pixel in the image, converting values as we go
 	For y=0 To hgt-1
		For x=0 To wdt -1 
			ARGB = ReaderJO.RunMethod("getArgb",Array As Object(x,y))
			rgb = modFunctions.getRGB(ARGB)
			r = rgb(1)
			g = rgb(2)
			b = rgb(3)
        	'Find the highest or lowest of the RGB values
        	If MaxOrMin = 0 Then 
				lGray = modFunctions.Minimum(r, g, b)
			Else 
				lGray = modFunctions.Maximum(r, g, b)
			End If
         	'Assign that gray value to each color channel
			Clr = fx.Colors.rgb(lGray, lGray, lGray)
			lGray=fx.Colors.To32Bit(Clr)
			WriterJO.RunMethod("setArgb",Array As Object(x , y ,lGray))				
		Next
	Next
	workingImg = OutputJO
End Sub
'Reduce to gray by selecting a single color channel (represeted by cChannel: 0 = Red, 1 = Green, 2 = Blue)
Public Sub MenuGrayscaleSingleChannel
	Dim x, y As Int
	Dim r,g,b As Int
	Dim rgb(4) As Int
	Dim ARGB,  lGray As Int
	Dim Clr As Paint
	Dim InputJO, OutputJO, ReaderJO, WriterJO As JavaObject
	OutputJO.InitializeNewInstance("javafx.scene.image.WritableImage",Array As Object(wdt,hgt))
	InputJO = img
	ReaderJO = InputJO.RunMethod("getPixelReader",Null)
	WriterJO = OutputJO.RunMethod("getPixelWriter",Null)		
    'Loop through each pixel in the image, converting values as we go
 	For y=0 To hgt-1
		For x=0 To wdt -1 
			ARGB = ReaderJO.RunMethod("getArgb",Array As Object(x,y))
			rgb = modFunctions.getRGB(ARGB)
			r = rgb(1)
			g = rgb(2)
			b = rgb(3)
	        Select Case cChannel
	            Case 0
	                lGray = r
	            Case 1
	                lGray = g
	            Case 2
	                lGray = b
	        End Select
        
        	'Assign that gray value to each color channel
  			Clr = fx.Colors.rgb(lGray, lGray, lGray)
			lGray=fx.Colors.To32Bit(Clr)
			WriterJO.RunMethod("setArgb",Array As Object(x , y ,lGray))				
		Next
	Next
	workingImg = OutputJO
End Sub
'Reduce to X # gray shades
Public Sub fGrayscaleCustom() As Int
	Dim x, y As Int
	Dim r,g,b As Int
	Dim rgb(4) As Int
	Dim ARGB,  lGray As Int
	Dim Clr As Paint
	Dim InputJO, OutputJO, ReaderJO, WriterJO As JavaObject
	OutputJO.InitializeNewInstance("javafx.scene.image.WritableImage",Array As Object(wdt,hgt))
	InputJO = workingImg
	ReaderJO = InputJO.RunMethod("getPixelReader",Null)
	WriterJO = OutputJO.RunMethod("getPixelWriter",Null)	
    
    'This conversion factor is the value we need to turn grayscale values in the [0,255] range into a specific subset of values
    Dim conversionFactor As Double
    conversionFactor = (255 / (numOfShades - 1))
    
    'Build a look-up table for our custom grayscale conversion results
    Dim LookUp(256) As Int
    Dim varDbl As Double 
    For x = 0 To 255
		varDbl = x
        lGray = (varDbl / conversionFactor + 0.5 )
        lGray = lGray * conversionFactor
       If lGray > 255 Then lGray = 255
        LookUp(x) = lGray
    Next 
    'Build another look-up table for our initial grayscale index calculation
    Dim grayLookUp(766) As Int
    For x = 0 To 765
        grayLookUp(x) = x / 3
    Next 
    'Loop through each pixel in the image, converting values as we go
 	For y=0 To hgt-1
		For x=0 To wdt -1 
			ARGB = ReaderJO.RunMethod("getArgb",Array As Object(x,y))
			rgb = modFunctions.getRGB(ARGB)
			r = rgb(1)
			g = rgb(2)
			b = rgb(3)
        	lGray = grayLookUp(r + g + b)
        	'Assign all color channels the new gray value
			Clr = fx.Colors.rgb(LookUp(lGray), LookUp(lGray), LookUp(lGray))
			lGray=fx.Colors.To32Bit(Clr)
			WriterJO.RunMethod("setArgb",Array As Object(x , y ,lGray))				
		Next
 	Next
	workingImg = OutputJO
End Sub

'Reduce to X # gray shades (dithered)
Public Sub fGrayscaleCustomDither
	Dim x, y As Int
	Dim r,g,b As Int
	Dim rgb(4) As Int
	Dim ARGB,  lGray As Int
	Dim Clr As Paint
	Dim InputJO, OutputJO, ReaderJO, WriterJO As JavaObject
	OutputJO.InitializeNewInstance("javafx.scene.image.WritableImage",Array As Object(wdt,hgt))
	InputJO = workingImg
	ReaderJO = InputJO.RunMethod("getPixelReader",Null)
	WriterJO = OutputJO.RunMethod("getPixelWriter",Null)	

    Dim initx As Int, initY As Int, finalX As Int, finalY As Int
    initx = 0
    initY = 0
    finalX = wdt - 1
    finalY = hgt - 1

    'This conversion factor is the value we need to turn grayscale values in the [0,255] range into a specific subset of values
    Dim conversionFactor As Double
    conversionFactor = (255 / (numOfShades - 1))

    'Build a look-up table for our custom grayscale conversion results
    Dim LookUp(256) As Int
    Dim varDbl As Double 
    For x = 0 To 255
		varDbl = x
        lGray = (varDbl / conversionFactor + 0.5 )
        lGray = lGray * conversionFactor
       If lGray > 255 Then lGray = 255
        LookUp(x) = lGray
    Next 
    'Dim DitherTable() As Short
    Dim xLeft As Int, xRight As Int, yDown As Int
    Dim errorVal As Double
    Dim dDivisor As Double
    Dim l As Int, newL As Int
    
    'Start by preparing a dithering table, which is obviously dependent on the requested dithering method
    Select Case ditheringOptions
		'No dithering
		Case 0
        	workingImg = OutputJO
			Return
        'False Floyd-Steinberg.  Coefficients derived from http://www.efg2.com/Lab/Library/ImageProcessing/DHALF.TXT
        Case 1
        
            'First, prepare a dither table
            Dim DitherTable(2, 2) As Short
            DitherTable(1, 0) = 3
            DitherTable(0, 1) = 3
            DitherTable(1, 1) = 2
            dDivisor = 8
            'Second, mark the size of the array in the left, right, and down directions
            xLeft = 0
            xRight = 1
            yDown = 1
            
        'Genuine Floyd-Steinberg.  Coefficients derived from http://www.efg2.com/Lab/Library/ImageProcessing/DHALF.TXT
        Case 2
        
            'First, prepare a Floyd-Steinberg dither table
			Dim DitherTable(3, 2) As Short			'********  Dim DitherTable(-1 To 1, 0 To 1) As Byte
            
            DitherTable(2, 0) = 7
            DitherTable(0, 1) = 3
            DitherTable(1, 1) = 5
            DitherTable(2, 1) = 1
            dDivisor = 16
            'Second, mark the size of the array in the left, right, and down directions
            xLeft = -1
            xRight = 1
            yDown = 1
            
        'Jarvis, Judice, Ninke.  Coefficients derived from http://www.efg2.com/Lab/Library/ImageProcessing/DHALF.TXT
        Case 3
            'First, prepare a dither table
            Dim DitherTable(5, 3) As Short				'*********  Dim DitherTable(-2 To 2, 0 To 2) As Byte
            
            DitherTable(3, 0) = 7
            DitherTable(4, 0) = 5
            DitherTable(0, 1) = 3
            DitherTable(1, 1) = 5
            DitherTable(2, 1) = 7
            DitherTable(3, 1) = 5
            DitherTable(4, 1) = 3
            
            DitherTable(0, 2) = 1
            DitherTable(1, 2) = 3
            DitherTable(2, 2) = 5
            DitherTable(3, 2) = 3
            DitherTable(4, 2) = 1
            
            dDivisor = 48
        
            'Second, mark the size of the array in the left, right, and down directions
            xLeft = -2
            xRight = 2
            yDown = 2
            
        'Stucki.  Coefficients derived from http://www.efg2.com/Lab/Library/ImageProcessing/DHALF.TXT
        Case 4
        
            'First, prepare a dither table
            Dim DitherTable(5, 3) As Short				'*********  Dim DitherTable(-2 To 2, 0 To 2) As Byte
            
            DitherTable(3, 0) = 8
            DitherTable(4, 0) = 4
            
            DitherTable(0, 1) = 2
            DitherTable(1, 1) = 4
            DitherTable(2, 1) = 8
            DitherTable(3, 1) = 4
            DitherTable(4, 1) = 2
            
            DitherTable(0, 2) = 1
            DitherTable(1, 2) = 2
            DitherTable(2, 2) = 4
            DitherTable(3, 2) = 2
            DitherTable(4, 2) = 1
            
            dDivisor = 42
        
            'Second, mark the size of the array in the left, right, and down directions
            xLeft = -2
            xRight = 2
            yDown = 2
            
        'Burkes.  Coefficients derived from http://www.efg2.com/Lab/Library/ImageProcessing/DHALF.TXT
        Case 5
        
            'First, prepare a dither table
            Dim DitherTable(5, 2) As Short				'*********  Dim DitherTable(-2 To 2, 0 To 1) As Byte
            
            DitherTable(3, 0) = 8
            DitherTable(4, 0) = 4
            
            DitherTable(0, 1) = 2
            DitherTable(1, 1) = 4
            DitherTable(2, 1) = 8
            DitherTable(3, 1) = 4
            DitherTable(4, 1) = 2
            
            dDivisor = 32
        
            'Second, mark the size of the array in the left, right, and down directions
            xLeft = -2
            xRight = 2
            yDown = 1
            
        'Sierra-3.  Coefficients derived from http://www.efg2.com/Lab/Library/ImageProcessing/DHALF.TXT
        Case 6
        
            'First, prepare a dither table
            Dim DitherTable(5, 3) As Short				'*********  Dim DitherTable(-2 To 2, 0 To 2) As Byte
            
            DitherTable(3, 0) = 5
            DitherTable(4, 0) = 3
            
            DitherTable(0, 1) = 2
            DitherTable(1, 1) = 4
            DitherTable(2, 1) = 5
            DitherTable(3, 1) = 4
            DitherTable(4, 1) = 2
            
            DitherTable(0, 2) = 0
            DitherTable(1, 2) = 2
            DitherTable(2, 2) = 3
            DitherTable(3, 2) = 2
            DitherTable(4, 2) = 0
            
            dDivisor = 32
        
            'Second, mark the size of the array in the left, right, and down directions
            xLeft = -2
            xRight = 2
            yDown = 2
            
        'Sierra-2.  Coefficients derived from http://www.efg2.com/Lab/Library/ImageProcessing/DHALF.TXT
        Case 7
        
            'First, prepare a dither table
            Dim DitherTable(5, 2) As Short				'*********  Dim DitherTable(-2 To 2, 0 To 1) As Byte
            
            DitherTable(3, 0) = 4
            DitherTable(4, 0) = 3
            
            DitherTable(0, 1) = 1
            DitherTable(1, 1) = 2
            DitherTable(2, 1) = 3
            DitherTable(3, 1) = 2
            DitherTable(4, 1) = 1
            
            dDivisor = 16
        
            'Second, mark the size of the array in the left, right, and down directions
            xLeft = -2
            xRight = 2
            yDown = 1
            
        'Sierra-2-4A.  Coefficients derived from http://www.efg2.com/Lab/Library/ImageProcessing/DHALF.TXT
        Case 8
        
            'First, prepare a dither table
			Dim DitherTable(3, 2) As Short			'********  Dim DitherTable(-1 To 1, 0 To 1) As Byte
            
            DitherTable(2, 0) = 2

            DitherTable(0, 1) = 1
            DitherTable(1, 1) = 1
            
            dDivisor = 4
        
            'Second, mark the size of the array in the left, right, and down directions
            xLeft = -1
            xRight = 1
            yDown = 1
            
        'Bill Atkinson's original Hyperdither/HyperScan algorithm.  (Note: Bill invented MacPaint, QuickDraw, and HyperCard.)
        ' This is the dithering algorithm used on the original Apple Macintosh.
        ' Coefficients derived from http://gazs.github.com/canvas-atkinson-dither/
        Case 9
        
            'First, prepare a dither table
            Dim DitherTable(4, 3) As Short				'**********  Dim DitherTable(-1 To 2, 0 To 2) As Byte
            
            DitherTable(2, 0) = 1
            DitherTable(3, 0) = 1
            
            DitherTable(0, 1) = 1
            DitherTable(1, 1) = 1
            DitherTable(2, 1) = 1
            
            DitherTable(1, 2) = 1
            
            dDivisor = 8
        
            'Second, mark the size of the array in the left, right, and down directions
            xLeft = -1
            xRight = 2
            yDown = 2
            
    End Select
    
  
    'First, we need a dithering table the same size as the image.  We make it of Single type to prevent rounding errors.
    ' (This uses a lot of memory, but on modern systems it shouldn't be a problem.)
    Dim dErrors(wdt, hgt) As Float
    
    Dim i As Long, j As Long
    Dim varFlt As Float 
    Dim QuickX As Int, QuickY As Int
    Dim GoTo As Boolean  
    'Now loop through the image, calculating errors as we go
    For y = initY To finalY
		For x = initx To finalX
        	'QuickVal = x 
        
            'Get the source pixel color values.  Because we know the image we're handed is already going to be grayscale,
            ' we can shortcut this calculation by only grabbing the red channel.
			ARGB = ReaderJO.RunMethod("getArgb",Array As Object(x,y))
			rgb = modFunctions.getRGB(ARGB)
			g = rgb(1)
        
        	'Convert those to a luminance value and add the value of the error at this location
        	l = g + dErrors(x, y)
        
        	'Convert that to a lookup-table-safe luminance (e.g. 0-255)
            If l < 0 Then
                newL = 0
            Else If l > 255 Then
                newL = 255
            Else
                newL = l
            End If
            'Write the new luminance value out to the image array
			Clr = fx.Colors.rgb(LookUp(newL), LookUp(newL), LookUp(newL))
			lGray=fx.Colors.To32Bit(Clr)
			WriterJO.RunMethod("setArgb",Array As Object(x , y ,lGray))	
            'Calculate an error for this calculation
            errorVal = l - LookUp(newL)
        
            'If there is an error, spread it
            If errorVal <> 0 Then
            
                'Now, spread that error across the relevant pixels according to the dither table formula
                For i = xLeft To xRight
	                For j = 0 To yDown
	                
	                    'First, ignore already processed pixels
	                    GoTo = (j = 0) AND (i <= 0) 
						If Not(GoTo) Then												'**********  If (j = 0) AND (i <= 0) Then GoTo NextDitheredPixel
		                    'Second, ignore pixels that have a zero in the dither table
							GoTo = DitherTable(i - xLeft, j) = 0 
		                    If Not(GoTo) Then 											'**********  If DitherTable(i, j) = 0 Then GoTo NextDitheredPixel
			                    QuickX = x + i
			                    QuickY = y + j
			                    'Next, ignore target pixels that are off the image boundary
								GoTo = QuickX < initx
			                    If Not(GoTo) Then 										'**********  If QuickX < initX Then GoTo NextDitheredPixel
									GoTo = QuickX > finalX
			                    	If  Not(GoTo) Then									'**********  If QuickX > finalX Then GoTo NextDitheredPixel
										GoTo =  QuickY > finalY
			                    		If Not(GoTo) Then 								'**********   If QuickY > finalY Then GoTo NextDitheredPixel
						                    'If we've made it all the way here, we are able to actually spread the error to this location
											varFlt = DitherTable(i-xLeft, j)
						                    dErrors(QuickX, QuickY) = dErrors(QuickX, QuickY) + (errorVal * varFlt / dDivisor)
										End If
									End If
								End If
							End If
						End If			                
'NextDitheredPixel:     
					Next 
            	Next 
        	End If
    	Next 
	Next 
 	workingImg = OutputJO

    
End Sub

Private Sub cboDithering_SelectedIndexChanged(Index As Int, Value As Object)
	updateImg
End Sub
Private Sub cboMethod_SelectedIndexChanged(Index As Int, Value As Object)
    UpdateVisibleControls
	updateImg
End Sub
Private Sub txtShades_Action
	sldShades.RequestFocus 
End Sub
Private Sub txtShades_TextChanged (Old As String, New As String)
	Dim ch As String
	Dim lg As Int
	lg=New.Length
	If lg>0 Then
		lg=lg-1
		For i = 0 To lg
			ch=New.SubString2(i, i+1)
			If Not("0123456789".Contains(ch)) Then
				txtShades.Text =Old
				txtShades.SetSelection (lg, lg)
				Return
			End If
		Next
	End If			
End Sub
Private Sub txtShades_FocusChanged (HasFocus As Boolean)
	If HasFocus Then
		txtShades.Tag = 1
	Else
		txtShades.Text =Max(Min(txtShades.Text,sldShades.MaxValue),sldShades.MinValue)
		sldShades.Value= txtShades.Text
	End If			
End Sub
Private Sub sldShades_ValueChange (Value As Double)
	Dim v As Short =Value
	If txtShades.Tag = 1 Then
		txtShades.Tag = 0
	Else
		txtShades.Text = v
	End If
	If flag Then updateImg		
End Sub
Private Sub optDecompose_SelectedChange(Selected As Boolean)
	If flag Then updateImg		
End Sub
Private Sub OptRgb_SelectedChange(Selected As Boolean)
	If flag Then updateImg		
End Sub
Private Sub UpdateVisibleControls
    Select Case cboMethod.SelectedIndex 
        Case 3
		    APDecompose.Visible = True 
			APRgb.Visible = False 
        Case 4
		    APDecompose.Visible = False
 			APRgb.Visible = True
        Case Else
		    APDecompose.Visible = False
			APRgb.Visible = False

    End Select
End Sub

Private Sub set_rgbRadioCk (t As String) As Boolean 
	For Each rb As RadioButton In APRgb
		If rb.Text.ToUpperCase = t.ToUpperCase  Then
			rb.Selected = True
			Return True
		End If
	Next
	Return False
End Sub
Private Sub get_rgbRadioCk() As Int 
	Dim ct As Int = -1
	For Each rb As RadioButton In APRgb
		ct=ct+1
		If rb.Selected Then
			Return ct
		End If
	Next
	Return -1
End Sub
Private Sub set_DecomposeRadioCk (t As String) As Boolean 
	For Each rb As RadioButton In APDecompose
		If rb.Text.ToUpperCase = t.ToUpperCase  Then
			rb.Selected = True
			Return True
		End If
	Next
	Return False
End Sub
Private Sub get_DecomposeRadioCk As Int
	Dim ct As Int = -1
	For Each rb As RadioButton In APDecompose
		ct=ct+1
		If rb.Selected Then
			Return ct 
		End If
	Next
	Return -1
End Sub