﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
'Brightness and Contrast
'Based on PhotoDemon VB6
'Copyright ©2013-2014 by Tanner Helland
Sub Class_Globals
	Private fx As JFX
	Private cv As Canvas 	
	Private Img As Image
	Private AP As Pane
	Private wdt, hgt As Int
	Private flag As Boolean 	
	Private Bright As Int
	Private Contrast As Double
	Private TrueContrast As Boolean	
	Private txtBright As TextField
	Private txtContrast As TextField
	Private sldContrast As Slider
	Private sldBright As Slider
	Private chkSample As CheckBox
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize()
	flag=False
	AP.Initialize("")
End Sub
Public Sub BrghCtrt(c As Canvas,fr As Form, posy As Double)
	cv = c
	Img = cv.Snapshot 
	wdt = Img.Width 
	hgt = Img.Height
	AP.LoadLayout("fxBrghCtrt")
	sldContrast.MinValue = -100
	sldContrast.MaxValue = 100
	sldContrast.Value =0
	sldBright.MinValue=-255
	sldBright.MaxValue =255
	sldBright.Value = 0 
	fr.RootPane.AddNode(AP, 5, posy, -1, -1)
	'CallSubDelayed(Me,"BrightnessContrast")
	BrightnessContrast	
End Sub

'Single routine for modifying both brightness and contrast.  Brightness is in the range (-255,255) while
' contrast is (-100,100).  Optionally, the image can be sampled to obtain a true midpoint for the contrast function.
Private Sub BrightnessContrast
	flag = True
	Dim x, y As Int
	Dim r,g,b As Int
	Dim rgb(4) As Int
	Dim ARGB,  lGray As Int
	Dim Clr As Paint
	Dim InputJO, OutputJO, ReaderJO, WriterJO As JavaObject
	OutputJO.InitializeNewInstance("javafx.scene.image.WritableImage",Array As Object(wdt,hgt))
	InputJO = Img
	ReaderJO = InputJO.RunMethod("getPixelReader",Null)
	WriterJO = OutputJO.RunMethod("getPixelWriter",Null)	
	Bright = sldBright.Value
	Contrast = sldContrast.Value 
	TrueContrast=chkSample.Checked 
    'Local loop variables 
    Dim initX, initY, finalX, finalY As Int
    initX = 0
    initY = 0
    finalX = wdt-1
    finalY = hgt-1
    Dim workingImg As Image = OutputJO
    'These values will help us access locations in the array more quickly.
    ' (qvDepth is required because the image array may be 24 or 32 bits per pixel, and we want to handle both cases.)
    Dim QuickVal As Int
    
    'If the brightness value is anything but 0, process it
	If Bright <> 0 Then
  
  		'Look-up tables work brilliantly for brightnes
        Dim BrightTable(256) As Short
        Dim BTCalc As Short
        
        For x = 0 To 255
            BTCalc = x + Bright
            BrightTable(x) = Min(Max(BTCalc, 0), 255)
        Next 
        
        'Loop through each pixel in the image, converting values as we go
        For x = initX To finalX
            QuickVal = x 
        	For y = initY To finalY
	 			'Get the source pixel color values
				ARGB = ReaderJO.RunMethod("getArgb",Array As Object(QuickVal,y))
				rgb = modFunctions.getRGB(ARGB)
            	'Use the look-up table to perform an ultra-quick brightness adjustment
				r = BrightTable(rgb(1))
				g = BrightTable(rgb(2))
				b = BrightTable(rgb(3))    
				Clr = fx.Colors.rgb(r,g, b)
				ARGB=fx.Colors.To32Bit(Clr)		
				WriterJO.RunMethod("setArgb",Array As Object(QuickVal , y ,ARGB))						
        	Next
 		Next
		workingImg=OutputJO
	Else
		workingImg = Img
    End If
	Dim InputJO As JavaObject
	InputJO = workingImg
	ReaderJO = InputJO.RunMethod("getPixelReader",Null)	
    'If the contrast value is anything but 0, process it
    If Contrast <> 0 Then
        'Contrast requires an average value to operate correctly; it works by pushing luminance values away from that average.
        Dim Mean As Int
    
        'Sampled contrast is my invention; traditionally contrast pushes colors toward or away from gray.
        ' I like the option to push the colors toward or away from the image's actual midpoint, which
        ' may not be gray.  For most white-balanced photos the difference is minimal, but for images with
        ' non-traditional white balance, sampled contrast offers better results.(Tanner Helland)
        If TrueContrast Then
		    Dim rTotal, gTotal, bTotal As Int
		    rTotal = 0
		    gTotal = 0
		    bTotal = 0
		    Dim NumOfPixels As Long
		    NumOfPixels = 0
		    
		    For x = initX To finalX
		        QuickVal = x 
		    	For y = initY To finalY
		 			'Get the source pixel color values
					ARGB = ReaderJO.RunMethod("getArgb",Array As Object(QuickVal,y))
					rgb = modFunctions.getRGB(ARGB)
					r = rgb(1)
					g = rgb(2)
					b = rgb(3)    				
			        rTotal = rTotal + r
		        	gTotal = gTotal + g
		        	bTotal = bTotal + b
		        	NumOfPixels = NumOfPixels + 1
		    	Next 
		    Next
		    
		    rTotal = rTotal / NumOfPixels
		    gTotal = gTotal / NumOfPixels
		    bTotal = bTotal / NumOfPixels
		    Mean = (rTotal + gTotal + bTotal) / 3
        'If we're not using true contrast, set the mean to the traditional 127
        Else
            Mean = 127
        End If
        
        'Like brightness, contrast works beautifully with look-up tables
        Dim ContrastTable(256) As Int
		Dim CTCalc As Int
        For x = 0 To 255
            CTCalc = x + (((x - Mean) * Contrast) / 100)
			ContrastTable(x) = Min(Max(CTCalc, 0), 255)
        Next 
        
        'Loop through each pixel in the image, converting values as we go
        For x = initX To finalX
            QuickVal = x 
        	For y = initY To finalY
	 			'Get the source pixel color values
				ARGB = ReaderJO.RunMethod("getArgb",Array As Object(QuickVal,y))
				rgb = modFunctions.getRGB(ARGB)
            	'Use the look-up table to perform an ultra-quick contrast adjustment
				r = ContrastTable(rgb(1))
				g = ContrastTable(rgb(2))
				b = ContrastTable(rgb(3))    
				Clr = fx.Colors.rgb(r,g, b)
				ARGB=fx.Colors.To32Bit(Clr)		
				WriterJO.RunMethod("setArgb",Array As Object(QuickVal , y ,ARGB))					
        	Next
        Next
		cv.DrawImage(OutputJO,0,0,wdt,hgt)	
	Else
 		cv.DrawImage(workingImg,0,0,wdt,hgt)	
    End If

End Sub
Private Sub chkSample_CheckedChange(Checked As Boolean)
	If flag Then BrightnessContrast			
End Sub
Private Sub sldContrast_ValueChange (Value As Double)
	Dim v As Short =Value
	If txtContrast.Tag = 1 Then
		txtContrast.Tag = 0
	Else
		txtContrast.Text = v
	End If
	If flag Then BrightnessContrast			
End Sub
Private Sub txtContrast_Action
	sldContrast.RequestFocus 
End Sub
Private Sub txtContrast_TextChanged (Old As String, New As String)
	Dim ch As String
	Dim lg As Int
	lg=New.Length
	If lg>0 Then
		lg=lg-1
		For i = 0 To lg
			ch=New.SubString2(i, i+1)
			If Not("0123456789-".Contains(ch)) Then
				txtContrast.Text = Old
				txtContrast.SetSelection (lg, lg)
				Return
			End If
		Next
	End If				
End Sub
Private Sub txtContrast_FocusChanged (HasFocus As Boolean)
	If HasFocus Then
		txtContrast.Tag = 1
	Else
		txtContrast.Text =Max(Min(txtContrast.Text,sldContrast.MaxValue),sldContrast.MinValue)
		sldContrast.Value= txtContrast.Text
	End If			
End Sub
Private Sub txtBright_Action
	sldBright.RequestFocus 
End Sub
Private Sub txtBright_TextChanged (Old As String, New As String)
	Dim ch As String
	Dim lg As Int
	lg=New.Length
	If lg>0 Then
		lg=lg-1
		For i = 0 To lg
			ch=New.SubString2(i, i+1)
			If Not("0123456789-".Contains(ch)) Then
				txtBright.Text = Old
				txtBright.SetSelection (lg, lg)
				Return
			End If
		Next
	End If			
End Sub
Private Sub txtBright_FocusChanged (HasFocus As Boolean)
	If HasFocus Then
		txtBright.Tag = 1
	Else
		txtBright.Text =Max(Min(txtBright.Text,sldBright.MaxValue),sldBright.MinValue)
		sldBright.Value= txtBright.Text
	End If		
End Sub
Private Sub sldBright_ValueChange (Value As Double)
	Dim v As Short =Value
	If txtBright.Tag = 1 Then
		txtBright.Tag = 0
	Else
		txtBright.Text = v
	End If
	If flag Then BrightnessContrast			
End Sub