﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
#Event: ColorPicked(Color As Object)
'Class module
Sub Class_Globals
	Private fx As JFX
	Private cv As Canvas 	
	Private Img As Image
	Private AP As Pane
	Private wdt, hgt As Int	
	Private flag As Boolean 	
	Private eDistance, eAngle, eDepth As Double
	Private eColor As Int
	Private pColor As Paint 
	Private sldAngle As Slider
	Private txtAngle As TextField
	Private sldDistance As Slider
	Private txtDistance As TextField
	Private txtDepth As TextField
	Private sldDepth As Slider
	Dim clrPkr As JavaObject
	Private mModule As Object
	Private srcImageData(1,1) As Int
	Private mEventName As String	
	Private m_FinalX As Int, m_FinalY As Int
	Private m_EdgeMethod As Int, m_ColorDepth As Int, m_ColorDepthLoop As Int
	Private m_Interpolate As Boolean
	Private m_DstX As Int, m_DstY As Int	
	Private EDGE_CLAMP As Int = 0
    Private EDGE_REFLECT As Int = 1
    Private EDGE_WRAP As Int = 2
    Private EDGE_ERASE As Int = 3
    Private EDGE_ORIGINAL As Int = 4
    Private fixDistort As Boolean
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize()
	flag=False
	AP.Initialize("")
End Sub
Public Sub Emboss(c As Canvas,fr As Form, posy As Double)
	cv = c
	Img = cv.Snapshot 
	wdt = Img.Width 
	hgt = Img.Height
	AP.LoadLayout("fxEmboss")
	Dim ARGB1 As Paint
	ARGB1 = fx.Colors.rgb(128, 128, 128)
	eColor = fx.Colors.To32Bit(ARGB1)
	mModule = Me
	mEventName = "clrPkr"
	clrPkr.InitializeNewInstance("javafx.scene.control.ColorPicker",Null)
	setColor(ARGB1)
	'varint = clrPkr.RunMethod("getValue", null)
	'Create the Event Handler
	Dim E As Object = clrPkr.CreateEventFromUI("javafx.event.EventHandler","clrPkr",Null)
	clrPkr.RunMethod("setOnAction",Array(E))
	AP.AddNode(clrPkr,10,200,-1,-1)
	sldAngle.MinValue = -180
	sldAngle.MaxValue = 180
	sldAngle.Value= -52
	sldDistance.MaxValue = -10
	sldDistance.MaxValue = 10
	sldDistance.Value = -2
	sldDepth.MinValue = 0.01
	sldDepth.MaxValue = 10
	sldDepth.Value = 5
	fr.RootPane.AddNode(AP, 5, posy, -1, -1)
	PrepareImageData

End Sub
Private Sub PrepareImageData
	Dim srcImageData(wdt, hgt) As Int 
	Dim x, y As Int 
	Dim varInt As Int
	Dim InputJO,  ReaderJO, WriterJO As JavaObject
	InputJO = Img
	ReaderJO = InputJO.RunMethod("getPixelReader",Null)
	For x= 0 To wdt-1
		For y = 0 To hgt- 1
			varInt = ReaderJO.RunMethod("getArgb",Array As Object(x,y))
			srcImageData(x,y) = varInt
		Next
	Next
	UpdtImage	
		
End Sub
Private Sub UpdtImage
	flag=True
	Dim x, y As Int
	Dim rgb(4) As Int
	Dim ARGB,  lClr As Int
	Dim ARGB1 As Paint
	eDistance = sldDistance.Value 
	If eDistance = 0 Then eDistance = 0.01
	eDepth = sldDepth.Value 
    'Local loop variables
    Dim initX As Int, initY As Int, finalX As Int, finalY As Int
    initX = 0
    initY = 0
    finalX = wdt -1
    finalY = hgt - 1
    'These values will help us access locations in the array more quickly.
    Dim QuickVal As Int, QuickValRight As Int
    setDistortParameters(EDGE_CLAMP, True, finalX, finalY)
	
    'Color variables
    Dim r As Int, g As Int, b As Int
    Dim tR As Int, tG As Int, tB As Int, tA As Int
    Dim rBase As Int, gBase As Int, bBase As Int

	rgb=modFunctions.getRGB(eColor)
    rBase = rgb(1)
    gBase = rgb(2)
    bBase = rgb(3)
    
	eAngle = sldAngle.Value  * (cPI / 180)
    
    'Find the cos and sin of this angle and store the values
    Dim cosTheta As Double, sinTheta As Double
    cosTheta = Cos(eAngle)
    sinTheta = Sin(eAngle)
    
    'New X value, remapped around a center point of (0, 0)
    Dim nX As Double
    
    'Source X and Y values, which are used to solve for the hue of a given point
    Dim srcX As Double, srcY As Double

	cv.ClearRect(0,0,cv.Width,cv.Height)	    
	Dim OutputJO, WriterJO As JavaObject
	OutputJO.InitializeNewInstance("javafx.scene.image.WritableImage",Array As Object(wdt,hgt))
	WriterJO = OutputJO.RunMethod("getPixelWriter",Null)	    
	'Loop through each pixel in the image, converting values as we go
    For x = initX To finalX
        QuickVal = x 
        QuickValRight = (x + 1) 
    	For y = initY To finalY
			ARGB = srcImageData(x,y)
			rgb = modFunctions.getRGB(ARGB)
		    r = rgb(1)
		    g = rgb(2)
		    b = rgb(3)

			'Move x according to the user's distance parameter
	        nX = x + eDistance
        
			'Calculate a rotated source x/y pixel
	        srcX = cosTheta * (nX - x) + x
	        srcY = sinTheta * (nX - x) + y	
			rgb = getColorsFromSource( srcX, srcY)	    
	
	       'Calculate an emboss value for each color
	        r = (r - rgb(1)) * eDepth + rBase
	        g = (g - rgb(2)) * eDepth + gBase
	        b = (b - rgb(3)) * eDepth + bBase
	        'Clamp RGB values
	        If r > 255 Then
	            r = 255
	        Else If r < 0 Then
	            r = 0
	        End If
	        
	        If g > 255 Then
	            g = 255
	        Else If g < 0 Then
	            g = 0
	        End If
	        
	        If b > 255 Then
	            b = 255
	        Else If b < 0 Then
	            b = 0
	        End If
			ARGB1 = fx.Colors.rgb(r, g, b)
			lClr=fx.Colors.To32Bit(ARGB1)
			WriterJO.RunMethod("setArgb",Array As Object(x , y ,lClr))	
		Next
	Next
	cv.DrawImage(OutputJO,0,0,wdt,hgt)	
End Sub

Private Sub setDistortParameters(edgeMethod As Int, toInterpolate As Boolean, finalX As Int, finalY As Int)
    'm_ColorDepth = imgColorDepth
    m_ColorDepthLoop = m_ColorDepth - 1
    m_EdgeMethod = edgeMethod
    m_Interpolate = toInterpolate
    m_FinalX = finalX
    m_FinalY = finalY
End Sub
Private Sub getColorsFromSource(srcX As Double, srcY As Double) As Int()
	Dim res(4) As Int
    'First, fix any coordinates that lie outside the image
    Dim pt As PointApi  
	pt = FixDistortEdges(srcX, srcY)
    srcX = pt.X
	srcY = pt.Y 
    'Now, interpolate as necessary
    Dim quickValX As Int, quickValY As Int
    
    'fixDistort will only be set to TRUE when the current pixel needs to be erased
    If fixDistort Then
        res(1) = 0
        res(2) = 0
        res(3) = 0
        'If m_ColorDepth = 4 Then a = 0
    Else
    
        'Interpolate a new pixel value
        If m_Interpolate Then
            res = pInterpolate(srcX, srcY)
        'Round to the nearest coordinate value
        Else
    
            quickValX = srcX 
            quickValY = srcY

			res = modFunctions.getRGB(srcImageData(quickValX, quickValY))

            
        End If
        
    End If
	Return res
End Sub
'This function takes an x and y value - as floating-point - and uses their position to calculate an interpolated value
' for an imaginary pixel in that location.  Offset (r/g/b/alpha) and image color depth are also required.
Private Sub pInterpolate(x1 As Double, y1 As Double) As Int()
    Dim rgb(4) As Int  
	Dim pt As PointApi 
    'Retrieve the four surrounding pixel values
    Dim topLeft(4) As Double, topRight(4) As Double, bottomLeft(4) As Double, bottomRight(4) As Double
	rgb = modFunctions.getRGB(srcImageData(x1, y1))
    topLeft(1) = rgb(1)
    topLeft(2) = rgb(2)
    topLeft(3) = rgb(3)	

	Dim fixX As Double, fixY As Double
    
    'Pixels at the far edges of the image require special treatment during interpolation
    If x1 < m_FinalX Then
		rgb = modFunctions.getRGB(srcImageData(x1+1, y1))
	    topRight(1) = rgb(1)
	    topRight(2) = rgb(2)
	    topRight(3) = rgb(3)		
    Else
        fixX = x1 + 1
        fixY = y1
		pt = FixDistortEdges(fixX, fixY)
		fixX = pt.X 
		fixY = pt.y
        If fixDistort Then
            topRight(1) = 0
            topRight(2) = 0
            topRight(3) = 0
        Else
			rgb = modFunctions.getRGB(srcImageData(fixX, y1))
		    topRight(1) = rgb(1)
		    topRight(2) = rgb(2)
		    topRight(3) = rgb(3)				
        End If
    End If

	If y1 < m_FinalY Then
		rgb = modFunctions.getRGB(srcImageData(x1, y1 + 1))
	    bottomLeft(1) = rgb(1)
	    bottomLeft(2) = rgb(2)
	    bottomLeft(3) = rgb(3)			
    Else
        fixX = x1
        fixY = y1 + 1
        pt = FixDistortEdges(fixX, fixY)
		fixX = pt.X 
		fixY = pt.y
        If fixDistort Then 
            bottomLeft(1) = 0
            bottomLeft(2) = 0
            bottomLeft(3) = 0
        Else
			rgb = modFunctions.getRGB(srcImageData(x1, fixY))
		    bottomLeft(1) = rgb(1)
		    bottomLeft(2) = rgb(2)
		    bottomLeft(3) = rgb(3)					
        End If
    End If
    If x1 < m_FinalX Then
        If y1 < m_FinalY Then
			rgb = modFunctions.getRGB(srcImageData(x1 + 1, y1 + 1))
		    bottomRight(1) = rgb(1)
		    bottomRight(2) = rgb(2)
		    bottomRight(3) = rgb(3)					
        Else
            fixX = x1 + 1
            fixY = y1 + 1
            pt = FixDistortEdges(fixX, fixY)
			fixX = pt.X 
			fixY = pt.y
        	If fixDistort Then
	            bottomRight(1) = 0
	            bottomRight(2) = 0
	            bottomRight(3) = 0			
            Else
				rgb = modFunctions.getRGB(srcImageData(x1 + 1, fixY))
			    bottomRight(1) = rgb(1)
			    bottomRight(2) = rgb(2)
			    bottomRight(3) = rgb(3)					
            End If
        End If
    Else
        fixX = x1 + 1
        fixY = y1 + 1
        pt = FixDistortEdges(fixX, fixY)
		fixX = pt.X 
		fixY = pt.y
        If fixDistort Then
            bottomRight(1) = 0
            bottomRight(2) = 0
            bottomRight(3) = 0	
		Else
            If y1 < m_FinalY Then
				rgb = modFunctions.getRGB(srcImageData(fixX, y1 + 1))
			    bottomRight(1) = rgb(1)
			    bottomRight(2) = rgb(2)
			    bottomRight(3) = rgb(3)						
            Else
				rgb = modFunctions.getRGB(srcImageData(fixX, fixY))
			    bottomRight(1) = rgb(1)
			    bottomRight(2) = rgb(2)
			    bottomRight(3) = rgb(3)						
            End If
        End If
    End If
    
    'Calculate blend ratios
    Dim yBlend As Double
    Dim xBlend As Double, xBlendInv As Double
    yBlend = y1 - y1
    xBlend = x1 - x1
    xBlendInv = 1 - xBlend
    
    'Blend in the x-direction
    Dim topRowColor(4) As Double, bottomRowColor(4) As Double
    topRowColor(1) = topRight(1) * xBlend + topLeft(1) * xBlendInv
    topRowColor(2) = topRight(2) * xBlend + topLeft(2) * xBlendInv
    topRowColor(3) = topRight(3) * xBlend + topLeft(3) * xBlendInv
    bottomRowColor(1) = bottomRight(1) * xBlend + bottomLeft(1) * xBlendInv
    bottomRowColor(2) = bottomRight(2) * xBlend + bottomLeft(2) * xBlendInv
    bottomRowColor(3) = bottomRight(3) * xBlend + bottomLeft(3) * xBlendInv
    
    'Blend in the y-direction
    rgb(1) = bottomRowColor(1) * yBlend + topRowColor(1) * (1 - yBlend)
    rgb(2) = bottomRowColor(2) * yBlend + topRowColor(2) * (1 - yBlend)
    rgb(3) = bottomRowColor(3) * yBlend + topRowColor(3) * (1 - yBlend)
	Return rgb

End Sub
Public Sub FixDistortEdges(srcX As Double, srcY As Double) As PointApi

    Dim fixPt As PointApi 
	fixPt.X = srcX
	fixPt.Y = srcY
	
	Select Case m_EdgeMethod
    
        'Clamp
        Case EDGE_CLAMP
        
            If srcX < 0 Then srcX = 0
            If srcY < 0 Then srcY = 0
            If srcX > m_FinalX Then srcX = m_FinalX
            If srcY > m_FinalY Then srcY = m_FinalY
        
        'Reflect
        Case EDGE_REFLECT
        
            If srcX < 0 Then srcX = Abs(srcX)
            If srcY < 0 Then srcY = Abs(srcY)
            If srcX > m_FinalX Then srcX = m_FinalX - (srcX - m_FinalX)
            If srcY > m_FinalY Then srcY = m_FinalY - (srcY - m_FinalY)
        
            'If the modified pixel STILL lies outside the image, use modulo to move it in-bounds
            If srcX < 0 Then srcX = Modulo(srcX, (m_FinalX + 1))
            If srcY < 0 Then srcY = Modulo(srcY, (m_FinalY + 1))
            If srcX > m_FinalX Then srcX = Modulo(srcX, (m_FinalX + 1))
            If srcY > m_FinalY Then srcY = Modulo(srcY, (m_FinalY + 1))
        
        'Wrap
        Case EDGE_WRAP
        
            If srcX < 0 Then srcX = Modulo(srcX, (m_FinalX + 1))
            If srcY < 0 Then srcY = Modulo(srcY, (m_FinalY + 1))
            If srcX > m_FinalX Then srcX = Modulo(srcX, (m_FinalX + 1))
            If srcY > m_FinalY Then srcY = Modulo(srcY, (m_FinalY + 1))
        
        'Erase
        Case EDGE_ERASE
  			fixDistort  = True    
            If srcX < 0 Then
                Return  fixPt
            End If
            
            If srcY < 0 Then
                Return  fixPt
            End If
            
            If srcX > m_FinalX Then
                Return  fixPt
            End If
            
            If srcY > m_FinalY Then
                Return  fixPt
            End If
            
        Case EDGE_ORIGINAL
            If srcX < 0 Then
                srcX = m_DstX
                srcY = m_DstY
            End If
            
            If srcY < 0 Then
                srcX = m_DstX
                srcY = m_DstY
            End If
            
            If srcX > m_FinalX Then
                srcX = m_DstX
                srcY = m_DstY
            End If
            
            If srcY > m_FinalY Then
                srcX = m_DstX
                srcY = m_DstY
            End If
            
    End Select
	fixDistort = False
	fixPt.X = srcX
	fixPt.Y = srcY
   Return  fixPt
End Sub
'This is a modified module function; it handles negative values specially to ensure they work with certain distort functions
Public Sub Modulo(Quotient As Double, Divisor As Double) As Double
    Dim Fix As Int = (Quotient / Divisor)
	Dim Mdl As Double = Quotient - Fix * Divisor
	If Mdl < 0 Then Mdl = Mdl + Divisor
End Sub
Sub clrPkr_Event(MethodName As String,Args() As Object)
	'Pass the value back to the calling module
	If SubExists(mModule,mEventName & "_ColorPicked") Then
		CallSub2(mModule,mEventName & "_ColorPicked",clrPkr.RunMethod("getValue",Null))
	End If
End Sub
Sub clrPkr_ColorPicked(Color As Object)
	pColor = Color 
	eColor = fx.Colors.To32Bit(pColor)
	UpdtImage
End Sub
Sub setColor(Color As Paint)
	clrPkr.RunMethod("setValue",Array(Color))
	'Workaround for bug in ColorPicker that doesn't update the selected color
    Dim AJO As JavaObject
    AJO.InitializeNewInstance("javafx.event.ActionEvent",Null)
    clrPkr.RunMethod("fireEvent",Array As Object(AJO))
End Sub

Sub sldDepth_ValueChange (Value As Double)
	If txtDepth.Tag = 1 Then
		txtDepth.Tag = 0
	Else
		txtDepth.Text = NumberFormat(Value,1,2)
	End If
	If flag Then UpdtImage			
End Sub
Sub txtDepth_Action
	sldDepth.RequestFocus 
End Sub
Sub txtDepth_TextChanged (Old As String, New As String)
	Dim ch As String
	Dim lg As Int
	lg=New.Length
	If lg>0 Then
		lg=lg-1
		For i = 0 To lg
			ch=New.SubString2(i, i+1)
			If Not("0123456789-.".Contains(ch)) Then
				txtDepth.Text =Old
				txtDepth.SetSelection (lg, lg)
				Return
			End If
		Next
	End If		
End Sub
Sub txtDepth_FocusChanged (HasFocus As Boolean)
	If HasFocus Then
		txtDepth.Tag = 1
	Else
		txtDepth.Text =Max(Min(txtDepth.Text,sldDepth.MaxValue),sldDepth.MinValue)
		sldDepth.Value= txtDepth.Text
	End If				
End Sub
Sub txtDistance_Action
	sldDistance.RequestFocus 
End Sub
Sub txtDistance_TextChanged (Old As String, New As String)
	Dim ch As String
	Dim lg As Int
	lg=New.Length
	If lg>0 Then
		lg=lg-1
		For i = 0 To lg
			ch=New.SubString2(i, i+1)
			If Not("0123456789-.".Contains(ch)) Then
				txtDistance.Text =Old
				txtDistance.SetSelection (lg, lg)
				Return
			End If
		Next
	End If		
End Sub
Sub txtDistance_FocusChanged (HasFocus As Boolean)
	If HasFocus Then
		txtDistance.Tag = 1
	Else
		txtDistance.Text =Max(Min(txtDistance.Text,sldDistance.MaxValue),sldDistance.MinValue)
		sldDistance.Value= txtDistance.Text
	End If		
End Sub
Sub sldDistance_ValueChange (Value As Double)
	If txtDistance.Tag = 1 Then
		txtDistance.Tag = 0
	Else
		txtDistance.Text = NumberFormat(Value,1,2)
	End If
	If flag Then UpdtImage				
End Sub
Sub txtAngle_Action
	sldAngle.RequestFocus 
End Sub
Sub txtAngle_TextChanged (Old As String, New As String)
	Dim ch As String
	Dim lg As Int
	lg=New.Length
	If lg>0 Then
		lg=lg-1
		For i = 0 To lg
			ch=New.SubString2(i, i+1)
			If Not("0123456789-.".Contains(ch)) Then
				txtAngle.Text =Old
				txtAngle.SetSelection (lg, lg)
				Return
			End If
		Next
	End If			
End Sub
Sub txtAngle_FocusChanged (HasFocus As Boolean)
	If HasFocus Then
		txtAngle.Tag = 1
	Else
		txtAngle.Text =Max(Min(txtAngle.Text,sldAngle.MaxValue),sldAngle.MinValue)
		sldAngle.Value= txtAngle.Text
	End If			
End Sub
Sub sldAngle_ValueChange (Value As Double)
	If txtAngle.Tag = 1 Then
		txtAngle.Tag = 0
	Else
		txtAngle.Text = NumberFormat(Value,1,2)
	End If
	If flag Then UpdtImage			
End Sub
