﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private fx As JFX
	Private cv As Canvas 	
	Private AP As Pane	
	Private Img As Image
	Private lMidValue As Short	
	Private lbTexture  As TextField
	Private sldIntensity As Slider 
	Private txtIntensity As TextField
	Private imgVTexture As ImageView
	Private lblChosenColour As Label
	Private txtMidValue As TextField
	Private sldTexture As Slider
	Private txtSaturation As TextField
	Private sldSaturation As Slider	
	Private btLstTexture As ImageView
	Private LstTexture As ListView	
	Private slIntensity As Float, slTexture As Short, slSaturation As Float
	Private imgTexture As Image 
	Private wdt, hgt As Int

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	AP.Initialize("")
End Sub
Public Sub Texturize(c As Canvas, fr As Form, posy As Int  )
	cv = c
	Img = cv.Snapshot 
	wdt = Img.Width 
	hgt = Img.Height	
	AP.LoadLayout("cmdImgEfct")	
	Dim F As List
	Dim s As String 
	sldIntensity.Value = 100
	sldTexture.Value =64
	sldSaturation.Value = 100
	LstTexture.Items.Add("(None)")
	F =  File.ListFiles (File.DirApp & "\Texture") '
	For i=0 To F.Size-1
		s=F.Get(i)
		If s.ToLowerCase.EndsWith(".png") Then
			s = s.SubString2(0,s.Length-4)
			LstTexture.Items.Add(s)
		End If
	Next
	LstTexture.Visible=False
	fr.RootPane.AddNode(AP, 5, posy, -1, -1)
	LstTexture.SelectedIndex = -1
End Sub
Private Sub ApplyTexture
	Dim rgb(4) As Int
	Dim X ,Y, cx, cy, tx, ty, tcx, tcy As Int
	Dim lS As Int
	Dim fLightness, fIntensity, fSaturation As Float
	Dim fMidh, fMids, fMidl, fAmount As Float
	Dim hsl(3) As Float 
	Dim h, s, l As Float
	Dim r, g, b As Int
	fIntensity = sldIntensity.Value   / 100.0
	lMidValue = sldTexture.Value  
   	hsl = modFunctions.RGBToHSL (lMidValue, lMidValue, lMidValue)
	fMidh = hsl(0)
	fMids = hsl(1)
	fMidl = hsl(2)
	fSaturation = sldSaturation.Value  / 100.0
	Dim ARGB As Paint
	Dim ImgJO, TextJO, DestJO, RImgJO, RTextJO, WDestJO As JavaObject
	DestJO.InitializeNewInstance("javafx.scene.image.WritableImage",Array As Object(wdt,hgt))
	ImgJO = Img
	TextJO = imgTexture
	RImgJO = ImgJO.RunMethod("getPixelReader",Null)
	RTextJO = TextJO.RunMethod("getPixelReader",Null)
	WDestJO = DestJO.RunMethod("getPixelWriter",Null)	
	cv.ClearRect(0,0, cv.Width, cv.Height)	
	' Get position information:
	tx = 0: ty = 0
	tcx = imgTexture.Width - 1
	tcy = imgTexture.Height - 1
	cx = wdt-1
	cy = hgt - 1
	For Y = 0 To cy
		For X = 0 To cx 
			' Set the destination to src with brightness adjusted
			' to the texture:
			lS=RTextJO.RunMethod("getArgb",Array As Object(tx,ty))
			rgb = modFunctions.getRGB(lS)
			r = rgb(1)
			g = rgb(2)
			b = rgb(3)
			hsl = modFunctions.RGBToHSL (r, g, b)
			fLightness = hsl(2)
			fAmount = fLightness - fMidl
			lS=RImgJO.RunMethod("getArgb",Array As Object(X,Y))
			rgb =modFunctions.getRGB(lS)
			r = rgb(1)
			g = rgb(2)
			b = rgb(3)
			hsl = modFunctions.RGBToHSL (r, g, b)
			h = hsl(0)
			s = hsl(1)
			l = hsl(2)
         	l = l * (1 + fAmount * fIntensity)
			If (l > 1) Then l = 1
			If (l < 0) Then l = 0
			s = s * fSaturation
			If (s > 1) Then s = 1
			If (s < 0) Then s = 0
			rgb =modFunctions.HSLToRGB(h, s, l)
			r = rgb(1)
			g = rgb(2)
			b = rgb(3)
			ARGB = fx.Colors.rgb(r,g,b)
			lS=fx.Colors.To32Bit(ARGB)
			WDestJO.RunMethod("setArgb",Array As Object(X , Y ,lS))	
			tx = tx + 1
			If (tx > tcx) Then tx = 0
		Next
		ty = ty + 1: tx = 0
		If (ty > tcy) Then ty = 0
	Next
	cv.DrawImage(DestJO,0,0,wdt,hgt)	
End Sub
Sub LstTexture_SelectedIndexChanged(Index As Int)
	If Index = -1 Then 
		lbTexture.Text = ""
		Return
	End If
    Private s As String 
	Dim TThgt, TTwdt As Double
	s=LstTexture.Items.Get(Index)
	lbTexture.Text = s
	If s="(None)" Then
		cv.ClearRect(0,0,cv.Width,cv.Height)	
		cv.DrawImage(Img,0,0,wdt,hgt)	
		imgVTexture.Visible=False
	Else
		imgTexture.Initialize(File.DirApp & "\Texture", s & ".png")
		TTwdt = imgTexture.Width 
		TThgt=imgTexture.Height 
		imgVTexture.Width = TTwdt
		imgVTexture.Height =TThgt
		imgVTexture.SetImage(imgTexture)
		imgVTexture.Visible=True
		ApplyTexture
	End If
	LstTexture.Visible = False
End Sub

Sub btLstTexture_MouseClicked (EventData As MouseEvent)
	LstTexture.Visible = Not(LstTexture.Visible)
End Sub
Sub btLstTexture_MousePressed (EventData As MouseEvent)
	btLstTexture.Left =btLstTexture.Left + 1
	btLstTexture.Top = btLstTexture.Top + 1 
End Sub
Sub btLstTexture_MouseReleased (EventData As MouseEvent)
	btLstTexture.Left =btLstTexture.Left - 1
	btLstTexture.Top = btLstTexture.Top - 1 
End Sub

Sub txtIntensity_Action
	txtMidValue.RequestFocus 
End Sub
Sub txtIntensity_TextChanged (old As String, New As String)
	Dim ch As String
	Dim lg As Int
	lg=New.Length
	If lg>0 Then
		lg=lg-1
		For i = 0 To lg
			ch=New.SubString2(i, i+1)
			If Not("0123456789".Contains(ch)) Then
				txtIntensity.Text =old
				txtIntensity.SetSelection (lg, lg)
				Return
			End If
		Next
	End If
End Sub
Sub txtIntensity_FocusChanged (HasFocus As Boolean)
	If HasFocus Then
		txtIntensity.Tag = 1
	Else
		txtIntensity.Text =Max(Min(txtIntensity.Text,sldIntensity.MaxValue),sldIntensity.MinValue)	
		sldIntensity.Value= txtIntensity.Text
	End If

End Sub
Sub sldIntensity_ValueChange (Value As Double)
	Dim v As Short =Value
	If txtIntensity.Tag = 1 Then
		txtIntensity.Tag = 0
	Else
		txtIntensity.Text = v
	End If
	If LstTexture.SelectedIndex>0 Then
		ApplyTexture
	End If
End Sub
Sub sldTexture_ValueChange (Value As Double)
	Dim v As Short =Value
	lblChosenColour.Style ="-fx-background-color: rgb(" & v & ", " & v & ", " & v & ")"
	If txtMidValue.Tag = 1 Then
		txtMidValue.Tag = 0
	Else
		txtMidValue.Text = v	
	End If
	If LstTexture.SelectedIndex>0 Then
	
		ApplyTexture
	End If	
End Sub
Sub txtMidValue_Action
	txtSaturation.RequestFocus 
End Sub
Sub txtMidValue_TextChanged (old As String, New As String)
	Dim ch As String
	Dim lg As Int
	lg=New.Length
	If lg>0 Then
		lg=lg-1
		For i = 0 To lg
			ch=New.SubString2(i, i+1)		
			If Not("0123456789".Contains(ch)) Then
				txtMidValue.Text =old
				txtMidValue.SetSelection (lg, lg)
				Return
			End If
		Next
	End If	
End Sub
Sub txtMidValue_FocusChanged (HasFocus As Boolean)
	If HasFocus Then
		txtMidValue.Tag = 1
	Else
		txtMidValue.Text =Max(Min(txtMidValue.Text,sldTexture.MaxValue),sldTexture.MinValue)	
		sldTexture.Value= txtMidValue.Text
	End If

End Sub
Sub sldSaturation_ValueChange (Value As Double)
	Dim v As Short =Value
	If txtSaturation.Tag = 1 Then
		txtSaturation.Tag = 0
	Else
		txtSaturation.Text = v		
	End If
	If LstTexture.SelectedIndex>0 Then
		ApplyTexture
	End If	
End Sub
Sub txtSaturation_Action
	txtIntensity.RequestFocus
End Sub
Sub txtSaturation_TextChanged (old As String, New As String)
	Dim ch As String
	Dim lg As Int
	lg=New.Length
	If lg>0 Then
		lg=lg-1
		For i = 0 To lg
			ch=New.SubString2(i, i+1)		
			If Not("0123456789".Contains(ch)) Then
				txtSaturation.Text =old
				txtSaturation.SetSelection (lg, lg)
				Return
			End If
		Next
	End If		
End Sub
Sub txtSaturation_FocusChanged (HasFocus As Boolean)
	If HasFocus Then
		txtSaturation.Tag = 1
	Else
		txtSaturation.Text =Max(Min(txtSaturation.Text,sldSaturation.MaxValue),sldSaturation.MinValue)	
		sldSaturation.Value = txtSaturation.Text
	End If	
End Sub