﻿Type=StaticCode
Version=2.2
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private cv As Canvas 	
	Private myPath As String 
	Private myFile As String 	
End Sub
Public Sub LoadImg(Pth As String, Fl As String, c As Canvas) As Boolean 
	Dim wdt, hgt As Int
	Dim ext As String 
	cv = c
	myPath = Pth
	myFile = Fl
	cv.ClearRect(0,0,cv.Width,cv.Height)	
	If Not(File.Exists(myPath, myFile)) Then Return False
	wdt=myFile.Length 
	ext = myFile.SubString2(wdt-4, wdt).ToUpperCase 
	If Not(".JPG.PNG.BMP.GIF".Contains(ext)) Then Return False
	Main.Img.Initialize(myPath, myFile)
	wdt = Main.Img.Width 
	hgt=Main.Img.Height 
	cv.Width =wdt
	cv.Height = hgt
	cv.DrawImage(Main.Img,0,0,wdt,hgt)
	Return True
End Sub
Public Sub RGBToHSL(r As Int, G As Int, b As Int ) As Float()  
	Dim HSL(3) As Float 
	Dim mMax As Float
	Dim mMin As Float
	Dim delta As Float
	Dim rR As Float, rG As Float, rB As Float

   	rR = r / 255: rG = G / 255: rB = b / 255
        mMax = Maximum(rR, rG, rB) 
        mMin = Minimum(rR, rG, rB)
        HSL(2) = (mMax + mMin) / 2    '{This is the lightness}
        '{Next calculate saturation}
        If mMax = mMin Then
            'begin {Achromatic case}
            HSL(1) = 0
            HSL(0) = 0
     	'end {Achromatic case}
        Else
           'begin {Chromatic case}
                '{First calculate the saturation.}
           If HSL(2) <= 0.5 Then
               HSL(1) = (mMax - mMin) / (mMax + mMin)
           Else
               HSL(1) = (mMax - mMin) / (2 - mMax - mMin)
            End If
            '{Next calculate the hue.}
            delta = mMax - mMin
           If rR = mMax Then
                HSL(0) = (rG - rB) / delta    '{Resulting color is between yellow and magenta}
           Else If rG = mMax Then
                HSL(0) = 2 + (rB - rR) / delta '{Resulting color is between cyan and yellow}
           Else If rB = mMax Then
                HSL(0) = 4 + (rR - rG) / delta '{Resulting color is between magenta and cyan}
            End If
       'end {Chromatic Case}
      End If
	  Return HSL
'end {RGB_to_HLS}
End Sub
Public Sub HSLtoRGB(h As Float, s As Float, l As Float) As Int()
	Dim rR As Float, rG As Float, rB As Float
	Dim mMin As Float, mMax As Float
	Dim res(4) As Int

   If s = 0 Then
      ' Achromatic case:
      rR = l: rG = l: rB = l
   Else
      ' Chromatic case:
      ' delta = mMax-mMin
      If l <= 0.5 Then
         ' Get mMin value:
         mMin = l * (1 - s)
      Else
         ' Get mMin value:
         mMin = l - s * (1 - l)
      End If
      ' Get the mMax value:
      mMax = 2 * l - mMin
      
      ' Now depending on sector we can evaluate the h,l,s:
      If (h < 1) Then
         rR = mMax
         If (h < 0) Then
            rG = mMin
            rB = rG - h * (mMax - mMin)
         Else
            rB = mMin
            rG = h * (mMax - mMin) + rB
         End If
      Else If (h < 3) Then
         rG = mMax
         If (h < 2) Then
            rB = mMin
            rR = rB - (h - 2) * (mMax - mMin)
         Else
            rR = mMin
            rB = (h - 2) * (mMax - mMin) + rR
         End If
      Else
         rB = mMax
         If (h < 4) Then
            rR = mMin
            rG = rR - (h - 4) * (mMax - mMin)
         Else
            rG = mMin
            rR = (h - 4) * (mMax - mMin) + rG
         End If
         
      End If
            
   End If
   res(1) = rR * 255: res(2) = rG * 255: res(3) = rB * 255
   Return res
End Sub


'This function will return the luminance value of an RGB triplet.  Note that the value will be in the [0,255] range instead
' of the usual [0,1.0] one.
Public Sub getLuminance( r As Float, g As Float, b As Float) As Float
    Dim Mx, Mn As Float
    Mx = Maximum(r, g, b)
    Mn = Minimum(r, g, b)
    Return (Mx + Mn) / 2
End Sub
Public Sub Maximum(rR As Float, rG As Float, rB As Float) As Float
	Dim Mx As Float  
  	Return Max(rR,Max(rG, rB))
End Sub
Public Sub Minimum(rR As Float, rG As Float, rB As Float) As Float
	Dim Mn As Float
   	Return Min(rR, Min(rG, rB))
End Sub
Public Sub getRGB(rgb_Clr As Int) As Int()
    Dim res(4) As Int
    res(0) = Bit.UnsignedShiftRight(Bit.AND(rgb_Clr, 0xff000000), 24)	'Alpha
    res(1) = Bit.UnsignedShiftRight(Bit.AND(rgb_Clr, 0xff0000), 16)		'Red
    res(2) = Bit.UnsignedShiftRight(Bit.AND(rgb_Clr, 0xff00), 8)		'Green
	res(3) = Bit.AND(rgb_Clr, 0xff)										'Blue
    Return res 
End Sub